<template>
	<div>
        <section class="cg-pop-panel-wrap">
            <div class="cg-pop-panel-body  d-flex justify-content-center">
                <div class="cg-semi-body-contents">
                    <div class="float-panel-part text-center d-flex align-items-center justify-content-center">
                        <h3 class="font1 cg-section-sml-heading w700">Update Product</h3>
                    </div>
                    <form  @submit.prevent="formSubmit" id="form" enctype="multipart/form-data">
                    <div class="product-upload-form-wrap d-flex align-items-center justify-content-center">
                        <div class="col-md-10 cg-nice-top-line">
                            <div class="row d-flex add-btm-xsml align-items-start justify-content-center">
                                <div class="col-md-10 cg-top-input">
                                    <label for="product_name">Product Name</label>
                                    <input type="text" v-model="product_name" name="product_name" id="product_name" readonly/>
                                </div>
                                <div class="col-md-2 cg-top-input">
                                    <label for="product_price">Price</label>
                                    <input type="number" name="product_price" min="0" @blur="handleBlur" v-model="product_price" id="product_price" placeholder="$" v-bind:class="{ cg_error_class: this.validation_errors.product_price || product_price_error }" />
                                    <span v-if="product_price_error" class="text-danger"> {{product_price_error }}</span>
                                    <span v-if="this.validation_errors.product_price" class="text-danger"> {{this.validation_errors.product_price[0] }}</span>
                                </div>
                            </div>

                            <div class="row d-flex add-btm-xsml">
<!--                                <div class="col-md-4 cg-top-input">-->
<!--                                    <label for="product_category">Product Category</label>-->
<!--                                    <input type="text" v-model="product_category" name="product_name" id="product_category" readonly/>-->
<!--                                </div>-->

                                <div class="col-md-6 cg-top-input">
                                    <label for="product_sub_category">Category</label><br>
                                    <input type="text" v-model="product_sub_category" name="product_sub_category" id="product_sub_category" readonly/>
                                </div>

                                <div class="col-md-6 cg-top-input">
                                    <label for="cg-product-licences">License  <a href="#" class="licence-more" id="licence-more">More</a>  </label><br>
                                    <select id="cg-product-licences" name="product_license" @blur="handleBlur" v-model="product_license" class="w500 f13"  v-bind:class="{ cg_error_class: this.validation_errors.product_license || product_license_error }">
                                        <option value="">Select License</option>
                                        <option value="0">Single</option>
                                        <option value="1">Multiple</option>
                                    </select>
                                    <span v-if="product_license_error" class="text-danger"> {{product_license_error }}</span>
                                    <span v-if="this.validation_errors.product_license" class="text-danger"> {{this.validation_errors.product_license[0] }}</span>
                                </div>

                            </div>
                            <div class="row d-flex add-btm-xsml">
                            <div class="col-md-12 cg-top-input">
                                <label for="tag_line">Tagline</label>
                                <input type="text" v-model="tag_line" id="tag_line" name="tag_line" @blur="handleBlur" v-bind:class="{ cg_error_class: this.validation_errors.tag_line || tag_line_error }">
                                <span v-if="tag_line_error" class="text-danger"> {{tag_line_error }}</span>
                                <span v-if="this.validation_errors.tag_line" class="text-danger"> {{this.validation_errors.tag_line[0] }}</span>
                            </div>
                            </div>

                            <div class="row d-flex add-btm-xsml" v-if="external_url_status">
                                <div  class="col-md-12 cg-top-input">
                                    <label for="live_preview_link">Live Preview Link</label>
                                    <input type="text" v-model="live_preview_link" id="live_preview_link" name="live_preview_link" @blur="handleBlur" v-bind:class="{ cg_error_class: this.validation_errors.live_preview_link || live_preview_link_error }">
                                    <span v-if="live_preview_link_error" class="text-danger"> {{live_preview_link_error }}</span>
                                    <span v-if="this.validation_errors.live_preview_link" class="text-danger"> {{this.validation_errors.live_preview_link[0] }}</span>
                                </div>
                            </div>

                            <div class="row" v-if="properties_.length">
                                <div class="col-md-12 cg-category-filetypes">
                                    <label>Product Features</label>
                                    <div class="d-flex justify-content-start cg-category-checkbox-border">
                                        <div  v-for="property in properties_" class="cg-category-checkbox d-flex align-items-center">
                                            <label :for="'property'+ property.id" class="cg-shop-filter-check">{{ property.name}}
                                            <input type="checkbox" @blur="handleBlur" :id="'property'+ property.id" v-model="properties" :value="property.id"/>
                                            <span class="checkmark"></span>
                                            </label>
                                        </div>
                                    </div>
                                </div>
                            </div>


                            <div class="row" v-if="file_types_.length">
                                <div class="col-md-12 cg-category-filetypes">
                                    <label>File Types</label>
                                    <div class="d-flex justify-content-start cg-category-checkbox-border">
                                        <div  v-for="file_type in file_types_" class="cg-category-checkbox d-flex align-items-center">
                                            <label :for="'file_type'+ file_type.id" class="cg-shop-filter-check">{{ file_type.name}}
                                            <input type="checkbox" @blur="handleBlur" :id="'file_type'+ file_type.id" v-model="file_types" :value="file_type.id"/>
                                                <span class="checkmark"></span>
                                            </label>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="row" v-if="application_supports_.length">
                                <div class="col-md-12 cg-category-filetypes">
                                    <label>Application Supports</label>
                                    <div class="d-flex justify-content-start cg-category-checkbox-border">
                                        <div  v-for="application_support in application_supports_" class="cg-category-checkbox d-flex align-items-center">
                                            <label :for="'application_support'+ application_support.id" class="cg-shop-filter-check"> {{ application_support.name}}
                                            <input type="checkbox" @blur="handleBlur" :id="'application_support'+ application_support.id" v-model="application_supports" :value="application_support.id"/>
                                            <span class="checkmark"></span>
                                           </label>
                                        </div>
                                    </div>
                                </div>
                            </div>



                            <div class="row">
                                <div class="col-md-12 cg-comment-type-box">
                                    <label for="description" id="ck_label">Description (Required 250 Characters)</label>
                                    <ckeditor id="description" @blur="handleBlur" v-on:keyup="charCount()" data-toggle="tooltip" title="Required 250 Characters" data-placement="top" v-model="description" :config="editorConfig"   v-bind:class="{ cg_error_class: validation_errors.description || description_error  }"></ckeditor>
                                    <span v-if="description_error" class="text-danger"> {{ description_error }}</span>
                                    <span v-if="validation_errors.description" class="text-danger"> {{validation_errors.description[0] }}</span>
                                </div>
                            </div>


                            <div class="row d-flex add-btm-xsml">
                                <div class="col-md-12 cg-top-input cg-prodcut-tag-input" id="product_tag_focus" v-bind:class="{ cg_error_class_tag: this.validation_errors.product_tags || product_tags_error }">
                                    <label for="product_tags">Product Tags (Separate by Enter)</label>
                                    <input type="text" v-model="product_tags" id="product_tags" name="product_tags" data-role="tagsinput">
                                    <span v-if="product_tags_error" class="text-danger"> {{product_tags_error }}</span>
                                    <span v-if="this.validation_errors.product_tags" class="text-danger"> {{this.validation_errors.product_tags[0] }}</span>
                                </div>
                            </div>

                            <div class="row" v-if="product_.status ==1">
                                <div class="col-md-12 cg-comment-type-box">
                                    <label for="change_logs">Change Logs</label>
                                    <textarea type="text" v-model="change_logs" id="change_logs" name="change_logs" placeholder="" @blur="handleBlur" v-bind:class="{ cg_error_class: this.validation_errors.change_logs || change_logs_error }"></textarea>
                                    <span v-if="change_logs_error" class="text-danger"> {{change_logs_error }}</span>
                                    <span v-if="this.validation_errors.change_logs" class="text-danger"> {{this.validation_errors.change_logs[0] }}</span>
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-md-4">
                                    <label class="upload-file-text">Upload ZIP File</label>
                                    <div class="file-drop-area" data-toggle="tooltip" title="Max File Size: 2GB" data-placement="top" v-bind:class="{ cg_error_class: this.validation_errors.product_file || this.file_message }">
                                        <span class="choose-file-button">Choose files</span>
                                        <span class="file-message">ZIP File Only</span>
                                        <input class="cg-file-upload-zone file-input" type="file" accept="application/zip" id="product_file" name="product_file" @blur="handleBlur" v-on:change="addFile">
                                    </div>
                                    <span v-if="this.validation_errors.product_file" class="text-danger"> {{this.validation_errors.product_file[0] }}</span>
                                    <span v-if="this.file_message" class="text-danger"> {{this.file_message }}</span>
                                </div>
                                <div class="col-md-4">
                                    <label class="upload-file-text">Upload Cover Image</label>
                                    <div class="file-drop-area" data-toggle="tooltip" title="Aspect Ratio: 3:2" data-placement="top" v-bind:class="{ cg_error_class: this.validation_errors.cover_image || this.cover_image_message }">
                                        <span class="choose-file-button">Choose files</span>
                                        <span class="file-message">PNG or JPEG Only</span>
                                        <input class="cg-file-upload-zone file-input" id="cover_image" accept="image/*" type="file" @blur="handleBlur" v-on:change="onImageChange">
                                    </div>
                                    <span v-if="this.validation_errors.cover_image" class="text-danger"> {{this.validation_errors.cover_image[0] }}</span>
                                    <span v-if="this.cover_image_message" class="text-danger"> {{this.cover_image_message }}</span>
                                </div>
                                <div class="col-md-4">
                                    <label class="upload-file-text" for="preview_images">Upload Preview Image</label>
                                    <div class="file-drop-area" data-toggle="tooltip" title="Aspect Ratio: 3:2" data-placement="top" v-bind:class="{ cg_error_class: this.validation_errors.preview_images || this.preview_image_message }">
                                        <span class="choose-file-button">Choose files</span>
                                        <span class="file-message" id="preview_images_display_count">PNG or JPEG Only</span>
                                        <input class="cg-file-upload-zone file-input" id="preview_images" accept="image/*" type="file" @blur="handleBlur" v-on:change="onImageChangeMultiple"  multiple>
                                    </div>
                                    <span v-if="this.validation_errors.preview_images" class="text-danger"> {{this.validation_errors.preview_images[0] }}</span>
                                    <span v-if="this.preview_image_message" class="text-danger"> {{this.preview_image_message }}</span>
                                </div>
                            </div>

                            <div class="row add-top-xsml cgfadein" v-if="image">
                                <div class="col-md-12">
                                    <label class="upload-file-text pad-left-sml">Cover Preview</label>
                                    <div class="uploaded-covers-slider">
                                        <div class="cover-image-preview cgfadein">
                                            <img :src="image" class="img-fluid" alt="Cover Image Preview">
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="row add-top-xsml cg-nice-btm-line cgfadein" v-if="images.length || product_.preview_photos.length">
                                <div class="col-md-12">
                                    <label class="upload-file-text">Preview Images</label>
                                    <div class="uploaded-image-slider row">
                                        <div v-for="(preview_photo, key) in product_.preview_photos" class="col-md-4 preview-img-uploaded cgfadein">
                                            <img :src="preview_photo.preview_photo_path" class="img-fluid" alt="Preview Images">
                                            <a class="preview-delete-button"  v-on:click="removeOldImage(key, preview_photo.id)">X</a>
                                        </div>
                                        <div v-for="(image, key) in images" class="col-md-4 preview-img-uploaded cgfadein">
                                            <img :src="image" class="img-fluid" alt="Preview Images">
                                            <a class="preview-delete-button"  v-on:click="removeImage(key)">X</a>
                                        </div>

                                    </div>
                                </div>
                            </div>
                            <div class="cg-category-extra-wrap">
                                <div class="d-flex justify-content-start cg-category-extra">
                                    <div class="cg-category-checkbox d-flex align-items-center">
                                        <label for="subscriptions_status" class="cg-shop-filter-check">Include in Subscription
                                        <input type="checkbox" @blur="handleBlur" :disabled="!product_.offer_status.subscriptions_edit" :enabled="product_.offer_status.subscriptions_edit" value="1" name="subscriptions_status" v-model="subscriptions_status" id="subscriptions_status"/>
                                            <span class="checkmark"></span>
                                        </label>
                                    </div>
                                    <div class="cg-category-checkbox d-flex align-items-center">
                                        <label for="freebies_status" class="cg-shop-filter-check">Include in Freebies
                                        <input type="checkbox" @blur="handleBlur" :disabled="!product_.offer_status.freebies_edit" :enabled="product_.offer_status.freebies_edit" value="1" name="freebies_status" v-model="freebies_status" id="freebies_status"/>
                                            <span class="checkmark"></span>
                                        </label>
                                    </div>
                                    <div class="cg-category-checkbox d-flex align-items-center">
                                        <label for="offers_status" class="cg-shop-filter-check"> Include in Offers
                                        <input type="checkbox" @blur="handleBlur" :disabled="!product_.offer_status.offers_edit" :enabled="product_.offer_status.offers_edit" value="1" name="offers_status" v-model="offers_status" id="offers_status"/>
                                            <span class="checkmark"></span>
                                        </label>
                                    </div>
                                </div>
                            </div>


<!--                            <div class="d-flex justify-content-center">-->
<!--                                <input type="submit" value="Update Product" name="submit" id="submit" />-->
<!--                            </div>-->

                            <div class="d-ﬂex justify-content-center submit-product-btn-wrap">
                                <button id="submit" type="submit" name="submit" class="ﬁrst font1 w600 f14 submit-product-btn">Update Product</button>
                            </div>

                        </div>
                    </div>
</form>




                </div>
            </div>
        </section>
        <div class="cg-toast-one" v-if="percentCompleted >= 0">
            <ul class="d-flex justify-content-between">
                <li class="first"><p>{{ percentCompleted }}% Uploaded</p></li>
            </ul>
        </div>
	</div>
</template>
<script>
    import CKEditor from 'ckeditor4-vue';
    export default {
        props: ['user_url','product_url','product','get_properties','get_file_types','get_application_supports','assigned_properties','assigned_file_types','assigned_application_supports'],
        components: {
            // Use the <ckeditor> component in this view.
            ckeditor: CKEditor.component
        },
        data(){
            return {
                user_url_:this.user_url,
                product_url_:this.product_url,
                csrf: document.querySelector('meta[name="csrf-token"]').getAttribute('content'),
                product_:JSON.parse(this.product),
                product_name:'', product_category: "", product_sub_category: "", product_license:0, properties: [],product_price:0,
                application_supports: [], file_types: [], tag_line:'', live_preview_link:'', description:'',
                product_tags:'', change_logs:'', cover_image:'', preview_images:[], image: '', images:[], product_file:'', removed_previews:[], log_status:false,

                properties_: JSON.parse(this.get_properties),
                application_supports_: JSON.parse(this.get_application_supports),
                file_types_: JSON.parse(this.get_file_types),

                success:'',
                validation_errors:{},
                success_message:'',
                error_message:'',
                file_message:'',
                cover_image_message:'',
                preview_image_message:'',

                external_url_status:0,
                subscriptions_status:0,
                freebies_status:0,
                offers_status:0,

                percentCompleted:-1,
                description_count:0,

                product_category_error: '', name_error:'', product_sub_category_error: '', product_price_error:'',
                tag_line_error:'', live_preview_link_error:'', description_error:'', product_tags_error:'', cover_image_error:'',
                preview_images_error:'', product_file_error:'', product_license_error:'',change_logs_error:'',

                editorConfig: {
                    // The configuration of the editor.
                    toolbar: [ [ 'Bold', 'Italic'] ]
                }


            }
        },
        mounted()
            {
                this.product_name=this.product_.name;
                this.product_category=this.product_.product_sub_category.product_category.name;
                this.product_sub_category=this.product_.product_sub_category.name;
                this.product_price=this.product_.price;
                this.tag_line=this.product_.tag_line;
                this.description=this.product_.description;
                this.description_count = this.product_.description.length,
                this.product_license=this.product_.product_license;
                this.external_url_status=this.product_.product_sub_category.product_category.external_link_status;
                this.subscriptions_status=this.product_.offer_status.subscriptions_status;
                this.freebies_status=this.product_.offer_status.freebies_status;
                this.offers_status=this.product_.offer_status.offers_status,
                this.properties = JSON.parse(this.assigned_properties);
                this.file_types = JSON.parse(this.assigned_file_types);
                this.application_supports = JSON.parse(this.assigned_application_supports);
                this.image=this.product_.cover_photo_path;
                this.live_preview_link=this.product_.external_url;
                this.product_tags=this.product_.product_tags;
                if(this.live_preview_link == null || this.live_preview_link == "null" || this.live_preview_link == "") this.live_preview_link="";
                if(this.product_tags == null || this.product_tags == "null" || this.product_tags == "") this.product_tags="";
                this.loadJs('/javascripts/custom/preview-image.js', function() {
                    //Stuff to do after someScript has loaded
                });
            },
        methods:{

        loadJs(url, callback) {
            jQuery.ajax({
              url: url,
              dataType: 'script',
              success: callback,
              async: true
            });
          },

            charCount: function(){
                this.description_count = this.description.length;
            },
             onImageChange(e) {
                let files = e.target.files || e.dataTransfer.files;
                this.cover_image_message ='';
                if (!files.length)
                {
                    this.cover_image_message ='No File Selected';
                    return;
                }
                else
                {
                    let t = files[0].type.split('/').pop().toLowerCase();
                    if (t != "jpeg" && t != "jpg" && t != "png" && t != "bmp" && t != "gif") {
                       // alert('Please select a valid image file');
                        this.cover_image_message ='Please select a valid image file';
                        document.getElementById("cover_image").value = '';
                        return false;
                    }
                    if (files[0].size > 1024000) {
                       // alert('Max Upload size is 1MB only');
                        this.cover_image_message ='Max Upload size is 1MB only';
                        document.getElementById("cover_image").value = '';
                        return false;
                    }

                    this.createImage(files[0]);
                }


            },
            createImage(file) {
                let reader = new FileReader();
                let vm = this;
                reader.onload = (e) => {
                    vm.image = e.target.result;
                };
                reader.readAsDataURL(file);
                this.cover_image = file;
            },
            onImageChangeMultiple(e) {
                let files = [];
                 files = e.target.files || e.dataTransfer.files;
                this.preview_image_message ='';
                if (!files.length)
                {

                    this.preview_image_message ='No File Selected';
                    return;
                }
                else
                {
                    this.slick_count = this.slick_count + 1;

                    for ( let i = 0; i < files.length; i++ )
                    {
                        let t = files[i].type.split('/').pop().toLowerCase();
                        if (t != "jpeg" && t != "jpg" && t != "png" && t != "bmp" && t != "gif") {
                           // alert('Please select a valid image file');
                            this.preview_image_message ='Please select a valid image file';
                            document.getElementById("preview_images").value = '';
                            return false;
                        }
                        if (files[i].size > 1024000) {
                           // alert('Max Upload size is 1MB only');
                            this.preview_image_message ='Max Upload size is 1MB only';
                            document.getElementById("preview_images").value = '';
                            return false;
                        }
                        this.preview_images.push(files[i]);
                        this.createImageMultiple(files[i]);

                    }

                }
                document.getElementById("preview_images").value = '';
                document.getElementById("preview_images_display_count").innerHTML = this.preview_images.length+" Images Selected";
            },
            createImageMultiple(file) {
                    let reader = new FileReader();
                    let vm = this;
                    reader.onload = (e) => {
                        vm.images.push(e.target.result);
                    };
                    reader.readAsDataURL(file);
                //    this.images = JSON.parse(JSON.stringify(this.images))

            },
            removeImage(key)
            {
                this.images.splice( key, 1 );
                this.preview_images.splice( key, 1 );
                document.getElementById("preview_images_display_count").innerHTML = this.preview_images.length+" Images Selected";
                this.product_tags = document.getElementById('product_tags').value;
            },
            removeOldImage(key, id)
            {
                this.product_.preview_photos.splice( key, 1 );
                this.removed_previews.push( id);
                this.product_tags = document.getElementById('product_tags').value;
            },

            addFile(e) {
                let pro_files = e.target.files || e.dataTransfer.files;
                this.file_message ='';
                if (!pro_files.length)
                {
                    this.file_message ='No File Selected';
                    return;
                }
                else
                {
                    let pro_t = pro_files[0].type.split('/').pop().toLowerCase();
                    if (pro_t != "zip") {
                        //alert('Please select a valid zip file');
                        this.file_message ='Please select a valid zip file';
                        document.getElementById("product_file").value = '';
                        return false;
                    }
                    if (pro_t[0].size > 2048000000) {
                       // alert('Max Upload size is 1MB only');
                        this.file_message ='Max Upload size is 2GB only';
                        document.getElementById("product_file").value = '';
                        return false;
                    }
                    this.product_file =  pro_files[0];
                    this.log_status = true;
                }


            },
            formSubmit(){

                document.getElementById('submit').disabled=true;
                document.getElementById('submit').innerHTML="Update Product <i class=\"fas fa-circle-notch fa-spin\"></i>";

                let currentObj = this;

                    currentObj.success_message='';
                    currentObj.error_message='';


               const config = {
                   headers: {
                       'content-type':'application/json',
                       'Accept':'application/json'
                   },
                   onUploadProgress: progressEvent => {
                       this.percentCompleted = Math.round( (progressEvent.loaded * 100) / progressEvent.total );
                   }
               }

                this.product_category_error= ''; this.name_error=''; this.product_sub_category_error= ''; this.product_price_error='';
                this.tag_line_error=''; this.live_preview_link_error=''; this.description_error=''; this.product_tags_error=''; this.cover_image_error='';
                this.preview_images_error=''; this.product_file_error=''; this.product_license_error='';
                this.product_tags = document.getElementById('product_tags').value;

                if(this.product_price ==0)
                {

                }
                else
                {
                    if(this.product_price == "" || this.product_price == null)
                    {
                        this.product_price_error = "The product price is required."
                        document.getElementById('product_price').focus()
                        document.getElementById('submit').disabled=false;
                        document.getElementById('submit').innerHTML="Update Product";
                        return;
                    }
                }

                if(this.product_license ==0)
                {

                }
                else
                {
                    if(this.product_license == "" || this.product_license == null)
                    {
                        this.product_license_error = "The product license is required."
                        document.getElementById('cg-product-licences').focus()
                        document.getElementById('submit').disabled=false;
                        document.getElementById('submit').innerHTML="Update Product";
                        return;
                    }
                }


                if(this.tag_line == "" || this.tag_line == null)
                {
                    this.tag_line_error = "The tag line is required."
                    document.getElementById('tag_line').focus()
                    document.getElementById('submit').disabled=false;
                    document.getElementById('submit').innerHTML="Update Product";
                    return;
                }
                if(this.description == "" || this.description == null || this.description.length < 250)
                {
                    this.description_error = "The description is required (Min 250 Characters)."
                    document.getElementById('description').focus()
                    window.location.hash = '#description';
                    document.getElementById('submit').disabled=false;
                    document.getElementById('submit').innerHTML="Update Product";
                    return;
                }
                if(this.product_tags == "" || this.product_tags == null)
                {
                    this.product_tags_error = "The product tags is required, (Separate by Enter)."
                    $('.bootstrap-tagsinput:first *:input[type!=hidden]:first').focus();
                    document.getElementById('submit').disabled=false;
                    document.getElementById('submit').innerHTML="Update Product";
                    return;
                }
                if(this.product_.status ==1 && this.log_status)
                {
                    if(this.change_logs == "" || this.change_logs == null)
                    {
                        this.change_logs_error = "The change logs is required"
                        document.getElementById('change_logs').focus()
                        document.getElementById('submit').disabled=false;
                        document.getElementById('submit').innerHTML="Update Product";
                        return;
                    }

                }




                if(this.subscriptions_status)
                {
                    this.subscriptions_status = 1;
                }
                else
                {
                    this.subscriptions_status = 0;
                }

                if(this.offers_status)
                {
                    this.offers_status = 1;
                }
                else
                {
                    this.offers_status = 0;
                }

                if(this.freebies_status)
                {
                    this.freebies_status = 1;
                }
                else
                {
                    this.freebies_status = 0;
                }

               let formData = new FormData();
                formData.append('product_id',  this.product_.id);
                formData.append('product_price',  this.product_price);
                formData.append('tag_line',  this.tag_line);
                formData.append('product_license',  this.product_license);
                formData.append('properties',  JSON.stringify(this.properties));
                formData.append('file_types',  JSON.stringify(this.file_types));
                formData.append('application_supports',  JSON.stringify(this.application_supports));
                formData.append('subscriptions_status',  this.subscriptions_status);
                formData.append('freebies_status',  this.freebies_status);
                formData.append('offers_status',  this.offers_status);
                formData.append('live_preview_link',  this.live_preview_link);
                formData.append('description',  this.description);
                formData.append('product_tags',  this.product_tags);
                formData.append('change_logs',  this.change_logs);
                formData.append('product_file',  this.product_file);
                formData.append('cover_image',  this.cover_image);
                formData.append('removed_previews',  JSON.stringify(this.removed_previews));

                for( let i = 0; i < this.preview_images.length; i++ ){
                    let file = this.preview_images[i];
                    formData.append('preview_images[' + i + ']', file);
                }

                //formData.append('preview_images', this.preview_images);

                axios.post(this.product_url +'/edit_product', formData, config).then((response)=>{

                    document.getElementById('submit').disabled=false;
                    document.getElementById('submit').innerHTML="Update Product";

                   if(response.data.status == 'validation_error')
                   {
                       currentObj.percentCompleted = -1;
                       currentObj.validation_errors = response.data.errors
                       if(this.validation_errors.product_price)
                       {
                           document.getElementById('product_price').focus()
                       }

                       else if(this.validation_errors.product_license)
                       {
                           document.getElementById('cg-product-licences').focus()
                       }
                       else if(this.validation_errors.tag_line)
                       {
                           document.getElementById('tag_line').focus()
                       }
                       else if(this.validation_errors.live_preview_link)
                       {
                           document.getElementById('live_preview_link').focus()
                       }
                       else if(this.validation_errors.description)
                       {
                           document.getElementById('description').focus()
                       }
                       else if(this.validation_errors.product_tags)
                       {
                           document.getElementById('product_tag_focus').focus()
                       }
                       else if(this.validation_errors.product_license)
                       {
                           document.getElementById('cg-product-licences').focus()
                       }
                       else if(this.validation_errors.product_file)
                       {
                           document.getElementById('product_file').focus()
                       }
                       else if(this.validation_errors.cover_image)
                       {
                           document.getElementById('cover_image').focus()
                       }
                       else if(this.validation_errors.preview_image)
                       {
                           document.getElementById('preview_images').focus()
                       }
                       else
                       {
                           document.getElementById('name').focus()
                       }
                   }
                   else if(response.data.status == 'success')
                   {
                       currentObj.percentCompleted = -1;
                       location.href = "/product_details_message?product_url="+this.product_url_ +"&message="+response.data.message;
                       currentObj.success_message = response.data.message

                   }
                   else
                   {
                       currentObj.percentCompleted = -1;
                       currentObj.error_message = response.data.message

                   }




                    })
            },
            handleBlur(e) {
                this.product_tags = document.getElementById('product_tags').value;
            }



        },
        created: function(){
            this.loadJs('/javascripts/custom/product-tags.js', function() {
                //Stuff to do after someScript has loaded
            });
        }

    }
</script>
